Index: cprs/trunk/CPRS-Chart/Orders/fODBBank.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 829)
@@ -1,4 +1,3 @@
 unit fODBBank;
-
 interface
 
@@ -6,58 +5,57 @@
   SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
   Forms, Dialogs, StdCtrls, ORCtrls, ORfn, fODBase, ExtCtrls, ComCtrls, uConst,
-  ORDtTm, Buttons, Menus, ImgList;
+  ORDtTm, Buttons, Menus, ImgList, VA508AccessibilityManager, VAUtils;
 
 type
   TfrmODBBank = class(TfrmODBase)
-    pnlBB: TPanel;
-    pnlFull: TPanel;
+    dlgLabCollTime: TORDateTimeDlg;
+    ORWanted: TORDateTimeDlg;
+    pnlComments: TPanel;
+    btnUpdateComments: TButton;
+    btnCancelComment: TButton;
+    lblOrdComment: TLabel;
     pgeProduct: TPageControl;
-    tabInfo: TTabSheet;
+    TabInfo: TTabSheet;
     edtInfo: TCaptionRichEdit;
     TabDiag: TTabSheet;
     lblReqComment: TOROffsetLabel;
+    TabResults: TTabSheet;
+    edtResults: TCaptionRichEdit;
     pnlFields: TPanel;
-    dlgLabCollTime: TORDateTimeDlg;
-    ORWanted: TORDateTimeDlg;
     lblDiagComment: TOROffsetLabel;
-    txtDiagComment: TCaptionEdit;
-    pnlSelectedTests: TGroupBox;
-    lvSelectionList: TCaptionListView;
     lblUrgency: TLabel;
+    lblReason: TLabel;
+    lblSurgery: TLabel;
     cboUrgency: TORComboBox;
-    lblCollType: TLabel;
-    cboCollType: TORComboBox;
     chkConsent: TCheckBox;
-    lblPreparation: TLabel;
-    calWantTime: TORDateBox;
-    lblWanted: TLabel;
-    tReason: TEdit;
-    lblReason: TLabel;
     cboSurgery: TORComboBox;
-    lblSurgery: TLabel;
-    txtImmedColl: TCaptionEdit;
-    cboCollTime: TORComboBox;
-    lblCollTime: TLabel;
-    cmdImmedColl: TSpeedButton;
-    pnlCollTimeButton: TKeyClickPanel;
-    calCollTime: TORDateBox;
-    cboPreparation: TORComboBox;
-    btnRemove: TButton;
-    btnRemoveAll: TButton;
-    pnlTop: TPanel;
     pnlSelect: TPanel;
-    pnlDiagTests: TGroupBox;
+    pnlDiagnosticTests: TGroupBox;
     cboAvailTest: TORComboBox;
     pnlBloodComponents: TGroupBox;
     lblQuantity: TLabel;
+    lblModifiers: TLabel;
     cboAvailComp: TORComboBox;
     tQuantity: TEdit;
-    upQuantity: TUpDown;
-    TabResults: TTabSheet;
-    edtResults: TCaptionRichEdit;
-    btnAddTests: TORAlignSpeedButton;
-    ImageList1: TImageList;
-    lblModifiers: TLabel;
     cboModifiers: TORComboBox;
+    GroupBox1: TGroupBox;
+    cboQuick: TORComboBox;
+    pnlSelectedTests: TGroupBox;
+    lvSelectionList: TCaptionListView;
+    btnRemove: TButton;
+    btnRemoveAll: TButton;
+    cboReasons: TORComboBox;
+    lblRequiredField: TLabel;
+    memDiagComment: TRichEdit;
+    lblCollType: TLabel;
+    cboCollType: TORComboBox;
+    lblCollTime: TLabel;
+    cboCollTime: TORComboBox;
+    calWantTime: TORDateBox;
+    lblWanted: TLabel;
+    calCollTime: TORDateBox;
+    txtImmedColl: TCaptionEdit;
+    pnlCollTimeButton: TKeyClickPanel;
+    cmdImmedColl: TSpeedButton;
     lblTNS: TLabel;
     procedure FormCreate(Sender: TObject);
@@ -78,5 +76,4 @@
     procedure pgeProductChange(Sender: TObject);
     procedure cboCollTypeChange(Sender: TObject);
-    procedure btnAddTestsClick(Sender: TObject);
     procedure FormDestroy(Sender: TObject);
     procedure btnRemoveClick(Sender: TObject);
@@ -86,9 +83,22 @@
     procedure chkConsentClick(Sender: TObject);
     procedure cboUrgencyChange(Sender: TObject);
-    procedure txtDiagCommentChange(Sender: TObject);
-    procedure cboPreparationChange(Sender: TObject);
     procedure cboSurgeryChange(Sender: TObject);
-    procedure tReasonChange(Sender: TObject);
     procedure calCollTimeChange(Sender: TObject);
+    procedure cboQuickClick(Sender: TObject);
+    procedure tQuantityEnter(Sender: TObject);
+    procedure btnUpdateCommentsClick(Sender: TObject);
+    procedure btnCancelCommentClick(Sender: TObject);
+    procedure cboSurgeryClick(Sender: TObject);
+    procedure cboReasonsEnter(Sender: TObject);
+    procedure cboReasonsExit(Sender: TObject);
+    procedure tQuantityClick(Sender: TObject);
+    procedure tQuantityChange(Sender: TObject);
+    procedure cboReasonsChange(Sender: TObject);
+    procedure cboModifiersChange(Sender: TObject);
+    procedure lvSelectionListClick(Sender: TObject);
+    procedure cboAvailCompChange(Sender: TObject);
+    procedure cboCollTimeChange(Sender: TObject);
+    procedure memDiagCommentChange(Sender: TObject);
+    procedure cboUrgencyExit(Sender: TObject);
   protected
     FCmtTypes: TStringList ;
@@ -106,7 +116,10 @@
     procedure ExtractSurgeries(OutList:TStrings; AList:TStrings);
     procedure ExtractUrgencies(OutList:TStrings; AList:TStrings);
+    procedure ExtractTNSOrders(OutList:TStrings; AList:TStrings);
     procedure ExtractModifiers(OutList:TStrings; AList:TStrings);
+    procedure ExtractReasons(OutList:TStrings; AList:TStrings);
     procedure ExtractSpecimens(OutList:TStrings; AList:TStrings);
     procedure ExtractTypeScreen(OutList:TStrings; AList:TStrings);
+    procedure ExtractOther(OutList:TStrings; AList:TStrings);
     procedure ExtractPatientInfo(OutList:TStrings; AList:TStrings);
     procedure ExtractSpecimen(OutList:TStrings; AList:TStrings);
@@ -114,4 +127,6 @@
     procedure LoadUrgencies(AComboBox:TORComboBox);
     procedure LoadModifiers(AComboBox:TORComboBox);
+    procedure LoadReasons(AComboBox:TORComboBox);
+
   private
     FLastCollType: string;
@@ -123,5 +138,9 @@
     FEvtDivision: integer;
     FVbecLookup: string;
+    FQuickList:  Integer;
+    FQuickItems: TStringList;
+    FOrderAction: Integer;
     procedure ReadServerVariables;
+    procedure SetOnQuickOrder;
   public
     procedure SetupDialog(OrderAction: Integer; const ID: string); override;
@@ -153,4 +172,5 @@
     CollSamp: Integer;                    { index into CollSampList }
     Specimen: Integer;                    { IEN of specimen }
+    Urgency: Integer;                     { IEN of urgency }
     Comment: TStringList;                 { text of comment }
     TestReqComment: string;               { Name of required comment }
@@ -162,4 +182,6 @@
     SpecimenList: TStringList;            { Strings: IEN^Specimen Name }
     SpecListCount: integer;               { count of original contents of SpecimenList}
+    UrgencyList: TStringList;             { Strings: IEN^Urgency Name }
+    ForceUrgency: Boolean;                { true if not prompt Urgency }
     SurgeryList: TStringList;             { Strings: Surgeries}
     PatientInfo: TStringList;             { Text of Patient Information}
@@ -179,9 +201,13 @@
     procedure LoadCollSamp(AComboBox: TORComboBox);
     procedure LoadSpecimen(AComboBox: TORComboBox);
+    procedure LoadUrgency(CollType: string; AComboBox:TORComboBox);
     function  NameOfCollSamp: string;
     function  NameOfSpecimen: string;
+    function  NameOfUrgency: string;
     function  ObtainCollSamp: Boolean;
     function  ObtainSpecimen: Boolean;
+    function  ObtainUrgency: Boolean;
     function  ObtainComment: Boolean;
+
   end;
 
@@ -202,14 +228,18 @@
 var
   uSelectedItems: TStringList;   //Selected Items in ListView- if TestYes =1 then test else component
-                                 //TestYes(1)^Test-Component(2)^Qty(3)^Sample(4,5)^Specimen(6,7)^Modifier(8)
+                                 //TestYes(1)^Test-Component(2)^Qty(3)^Modifier(4)^Specimen(5,6)^CollTime(7)^CollType(8)
   uVBECList: TStringList;        //List of items from VBEC api
   uTestsForResults: TStringList; //List of tests to show results
   uUrgencyList: TStringList;     //List of Urgencies
+  uTNSOrders: TStringList;       //List of Current orders for Type & Screen
   uModifierList: TStringList;    //List of Modifiers
+  uReasonsList: TStringList;     //List of Reasons for Request
   uRaw: TStringList;             //Results Array
   uTestSelected, uComponentSelected: Boolean;  //Used on Validate
-  uDfltUrgency: Integer;
+  uDfltUrgency: Integer;         //Default Urgency
+  uSelUrgency: String;          //Previously Selected Urgency - Used when components have been added for specific urgency
+  uSelSurgery: Integer;          //Selected Surgery for Blood order
   uSpecimen, uGetTnS: Integer;            //Set to 1 if a specimen for test is already in lab... no need to collect
-  uDfltCollType: string;
+  uDfltCollType, uReason: string;
   ALabTest: TLabTest;
   UserHasLRLABKey: boolean;
@@ -228,5 +258,5 @@
 
   TI_INFO = 0;    //Corresponds with pgeProduct TabIndex
-  TI_ORDER = 1;
+  TI_COMPONENT = 1;
   TI_RESULTS = 2;
 
@@ -239,4 +269,6 @@
   i: integer;
   AList, ATests: TStringList;
+  ListCount: Integer;
+  x: string;
 begin
   AutoSizeDisabled := True;
@@ -248,12 +280,20 @@
   uTestsForResults := TStringList.Create;
   uUrgencyList := TStringList.Create;
+  uTNSOrders := TStringList.Create;
   uModifierList := TStringList.Create;
+  uReasonsList := TStringList.Create;
   uRaw := TStringList.Create;
   uSpecimen := 0;
   uGetTnS := 0;
+  uReason := '';
   lblTNS.Caption := '';
   lblTNS.Visible := false;
+  pnlMessage.Visible := false;
   uDfltUrgency := 9;
-  TabResults.ImageIndex := 0;
+  uSelUrgency := '';
+  uSelSurgery := 0;
+  TabResults.Caption := 'Lab Results';
+  edtResults.Lines.Clear;
+  edtResults.Lines.Add('Lab results are ONLY available after selecting/adding a component on the Blood Bank Orders tab that has been designated for results retrieval.');
   Responses.Clear;
   try
@@ -265,6 +305,4 @@
     LRFSCH   := '';
     LRORDERMODE := TORDER_MODE_INFO;
-    DisableComponentControls;
-    DisableDiagTestControls;
     FLastColltime := '';
     FLastLabCollTime := '';
@@ -277,7 +315,4 @@
     AllowQuickOrder := True;
     StatusText('Loading Dialog Definition');
-    lblReqComment.Visible := False ;
-    lblModifiers.Enabled := False;
-    cboModifiers.Enabled := False;
     FCmtTypes := TStringList.Create;
     for i := 0 to 6 do FCmtTypes.Add(CmtType[i]) ;
@@ -289,11 +324,12 @@
       EvtDivision := StrToIntDef(GetEventDiv1(IntToStr(Self.EvtID)),0);
       if EvtDelayLoc>0 then
-        AList.Assign(ODForLab(EvtDelayLoc,EvtDivision))
+        FastAssign(ODForLab(EvtDelayLoc,EvtDivision), AList)
       else
-        AList.Assign(ODForLab(Encounter.Location,EvtDivision));
+        FastAssign(ODForLab(Encounter.Location,EvtDivision), AList);
     end else
-      AList.Assign(ODForLab(Encounter.Location)); // ODForLab returns TStrings with defaults
+      FastAssign(ODForLab(Encounter.Location), AList); // ODForLab returns TStrings with defaults
     CtrlInits.LoadDefaults(AList);
     InitDialog;
+    GroupBox1.Visible := True;
     with CtrlInits do
     begin
@@ -309,5 +345,5 @@
       StatusText('Initializing List of Tests');
       FVbecLookup := 'S.VBT';
-      cboAvailTest.InitLongList('');
+      cboAvailTest.InitLongList('');      //Populates cboAvailTest control based on S.VBT xref
     end;
     cboAvailComp.Clear;
@@ -329,25 +365,37 @@
     AList.Clear;
     ExtractUrgencies(uUrgencyList, uVBECList);
+    ExtractTNSOrders(uTNSOrders, uVBECList);
     LoadUrgencies(cboUrgency);
-    cboUrgency.SelectByID(IntToStr(uDfltUrgency));
     ExtractModifiers(uModifierList, uVBECList);
+    ExtractReasons(uReasonsList, uVBECList);
     LoadModifiers(cboModifiers);
-    calWantTime.Text := FormatFMDateTime('mmm dd,yyyy@hh:nn',DateTimeToFMDateTime(Now));
-    //cboPreparation.SelectByID('I');
-    memMessage.Visible := false;
-    memOrder.Visible := false;
-    cmdAccept.Visible := false;
+    LoadReasons(cboReasons);
+    calWantTime.Text := 'NOW'; //FormatFMDateTime('mmm dd,yyyy@hh:nn',DateTimeToFMDateTime(Now));
     pgeProduct.TabIndex := TI_INFO;
-    lvSelectionList.Column[0].Width := 200;
-    lvSelectionList.Column[1].Width := 40;
+    lvSelectionList.Column[0].Width := 240;
+    lvSelectionList.Column[1].Width := 30;
+    lvSelectionList.Column[2].Width := 100;
+    DisableComponentControls;
+    DisableDiagTestControls;
     pgeProduct.ActivePageIndex := TI_INFO;
-    PreserveControl(cboAvailTest);
-    PreserveControl(cboAvailComp);
-    PreserveControl(cboCollType);
-    PreserveControl(cboCollTime);
-    PreserveControl(calCollTime);
-    PreserveControl(calWantTime);
     StatusText('');
-
+    x := 'VBEC';
+    FQuickItems := TStringList.Create;
+    ListForQuickOrders(FQuickList, ListCount, x);
+    if ListCount > 0 then
+      begin
+        SubsetOfQuickOrders(FQuickItems, FQuickList, 0, 0);
+      end else
+      begin
+        ListCount := 1;
+        FQuickItems.Add('0^(No quick orders available)');
+      end;
+
+    FastAssign(FQuickItems, cboQuick.Items);
+    if lvSelectionList.Items.Count > 0 then
+      begin
+        memOrder.Visible := true;
+        cmdAccept.Visible := true;
+      end;
   finally
     AList.Free;
